/*
    ContactXfer - Transfer Contacts via Wireless Network

    Copyright (C) 2008  Nigel D. Stepp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

    Nigel Stepp <stepp@atistar.net>
    http://www.atistar.net/~stepp/contactxfer/

    $Id: BrowserViewController.h 282 2008-09-02 22:56:58Z stepp $
*/

#import <UIKit/UIKit.h>


@interface BrowserViewController : UITableViewController {

	UITableView *browserView;
	NSObject *statusDelegate;
	
    // Keeps track of available services
    NSMutableArray *services;
	NSMutableArray *resolvingServices;
	
	BOOL searching;
	BOOL dirty;
}

@property (nonatomic, retain) UITableView *browserView;
@property (nonatomic, retain) NSMutableArray *services;
@property (nonatomic, retain) NSMutableArray *resolvingServices;

- (void)show;
- (void)hide;
- (void)setStatusDelegate:(id)delegate;

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath;


// NSNetServiceBrowser delegate methods for service browsing

- (void)netServiceBrowserWillSearch:(NSNetServiceBrowser *)browser;
- (void)netServiceBrowserDidStopSearch:(NSNetServiceBrowser *)browser;
- (void)netServiceBrowser:(NSNetServiceBrowser *)browser
			 didNotSearch:(NSDictionary *)errorDict;

- (void)netServiceBrowser:(NSNetServiceBrowser *)browser
		   didFindService:(NSNetService *)aNetService
			   moreComing:(BOOL)moreComing;

- (void)netServiceBrowser:(NSNetServiceBrowser *)browser
		 didRemoveService:(NSNetService *)aNetService
			   moreComing:(BOOL)moreComing;

// NSNetService delegate methods for service resolution
- (void)netServiceDidResolveAddress:(NSNetService *)netService;
- (void)netService:(NSNetService *)netService
	 didNotResolve:(NSDictionary *)errorDict;

// Other methods
- (BOOL)addressesComplete:(NSArray *)addresses
		   forServiceType:(NSString *)serviceType;


@end
