/*
    ContactXfer - Transfer Contacts via Wireless Network

    Copyright (C) 2008  Nigel D. Stepp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

    Nigel Stepp <stepp@atistar.net>
    http://www.atistar.net/~stepp/contactxfer/

    $Id: ContactXferViewController.h 282 2008-09-02 22:56:58Z stepp $
*/

#import <UIKit/UIKit.h>
#import <AddressBook/AddressBook.h>
#import <AddressBookUI/AddressBookUI.h>
#import "TCPServer.h"

@class BrowserViewController;

@interface ContactXferViewController : UIViewController <ABPeoplePickerNavigationControllerDelegate, ABNewPersonViewControllerDelegate> {
	// UI Elements
	IBOutlet UIButton *sendButton;
	IBOutlet UIButton *receiveButton;
	IBOutlet UIButton *cancelButton;
	IBOutlet UIButton *infoButton;
	
	IBOutlet UIActivityIndicatorView *indicator;
	IBOutlet UILabel *statusMessage;
	
	IBOutlet UIImageView *addrOutImg;
	IBOutlet UIImageView *addrInImg;
	
	IBOutlet BrowserViewController *browserController;
	
	NSNetServiceBrowser *serviceBrowser;
	TCPServer *tcpServer;
	NSData *contactData;
}

@property (nonatomic, retain) UIButton *sendButton;
@property (nonatomic, retain) UIButton *receiveButton;
@property (nonatomic, retain) UIButton *cancelButton;
@property (nonatomic, retain) UIButton *infoButton;

@property (nonatomic, retain) UIActivityIndicatorView *indicator;
@property (nonatomic, retain) UILabel *statusMessage;

@property (nonatomic, retain) UIImageView *addrOutImg;
@property (nonatomic, retain) UIImageView *addrInImg;

@property (nonatomic, retain) BrowserViewController *browserController;

@property (nonatomic, retain) NSNetServiceBrowser *serviceBrowser;
@property (nonatomic, retain) TCPServer *tcpServer;
@property (nonatomic, retain) NSData *contactData;


-(IBAction)startSend:(id)sender;
-(IBAction)startReceive:(id)sender;
-(IBAction)userCancel:(id)sender;
-(IBAction)showInfo:(id)sender;

-(void)haveDataToSend;
- (void)didFindService:(NSNetService *)service;


@end
